-----------------------------------------
--          FIR Filter User I/O        -- 
-- corr_filter_userio.vhd              --
-- Other files:                        --
--         corr_filter.vhd             --
--         corr_filter_userio.vhd      --
--                                     --
-- For capstone, Wulfsberg, 2009/2010  --
--                                     --
-- Author: Bryan Woolsey               --
-- Email: ragnarkon@nau.edu            --
-- VHDL Version:  VHDL-93              --
-- Date: 2-23-10                       --
-- Last Update: 4-22-10                --
-----------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;
use work.corr_filter_pkg.all;
use IEEE.std_logic_unsigned.all;

entity corr_filter_userio is
	port (
		channel_sel : in std_logic_vector(3 downto 0);  -- user switches
		channel_sel_io : out std_logic_vector(3 downto 0);  -- output to hex display
		channel_sel_out : out headervaltype -- output to filter, I hope
	);
end corr_filter_userio;

architecture arch of corr_filter_userio is

begin
        master : process (channel_sel)
        begin
			case (channel_sel) is
				when "0000" =>
					channel_sel_out <= work.corr_filter_pkg.ch_null;
				when "0001" =>
					channel_sel_out <= work.corr_filter_pkg.ch1_25;
				when "0010" =>
					channel_sel_out <= work.corr_filter_pkg.ch2_25;
				when "0011" =>
					channel_sel_out <= work.corr_filter_pkg.ch3_25;
				when "0100" =>
					channel_sel_out <= work.corr_filter_pkg.ch4_25;
				when "0101" =>
					channel_sel_out <= work.corr_filter_pkg.ch5_25;
				when "0110" =>
					channel_sel_out <= work.corr_filter_pkg.ch6_25;
				when "0111" =>
					channel_sel_out <= work.corr_filter_pkg.ch7_25;
				when "1000" =>
					channel_sel_out <= work.corr_filter_pkg.ch8_25;
--				when x"01001" =>
--					channel_sel_out <= work.corr_filter_pkg.ch9_25;
--				when x"01010" =>
--					channel_sel_out <= work.corr_filter_pkg.ch10_25;
--				when x"01011" =>
--					channel_sel_out <= work.corr_filter_pkg.ch11_25;
--				when x"01100" =>
--					channel_sel_out <= work.corr_filter_pkg.ch12_25;
--				when x"01101" =>
--					channel_sel_out <= work.corr_filter_pkg.ch13_25;
--				when x"01110" =>
--					channel_sel_out <= work.corr_filter_pkg.ch14_25;
--				when x"01111" =>
--					channel_sel_out <= work.corr_filter_pkg.ch15_25;
--				when x"10000" =>
--					channel_sel_out <= work.corr_filter_pkg.ch16_25;
--				when x"10001" =>
--					channel_sel_out <= work.corr_filter_pkg.ch17_25;
--				when x"10010" =>
--					channel_sel_out <= work.corr_filter_pkg.ch18_25;
--				when x"10011" =>
--					channel_sel_out <= work.corr_filter_pkg.ch19_25;
--				when x"10100" =>
--					channel_sel_out <= work.corr_filter_pkg.ch20_25;
				when others =>
					null;
			end case;
			
			if unsigned(channel_sel) < 9 then
				channel_sel_io <= channel_sel;
			end if;
		end process;
end arch;