-------------------------------------------------
-- Binary -> Hex converter                     -- 
--                                             --
-- For use on the Terasic DE1/DE2 test boards  --
--                                             --
--                                             --
-- Author: Bryan Woolsey                       --
-- Email: ragnarkon@nau.edu                    --
-- Date: 9-02-08                               --
--                                             --
-- VHDL Version:  VHDL-93                      --
-------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity hex_counter is
	port (
		bits : in std_logic_vector(3 downto 0);
		bits2 : in std_logic_vector(3 downto 0);
		sevenseg : out std_logic_vector(6 downto 0);
		sevenseg2 : out std_logic_vector(6 downto 0);
		errorled : out std_logic

	);
end hex_counter;

architecture behav of hex_counter is
	begin
	process(bits, bits2)
		begin
			case bits2 is
				--0
				when "0000" =>
					sevenseg2 <= "1000000";
					errorled <= '0';
				--1
				when "0001" =>
					sevenseg2 <= "1111001";
					errorled <= '0';
				--2
				when "0010" =>
					sevenseg2 <= "0100100";
					errorled <= '0';
				--3
				when "0011" =>
					sevenseg2 <= "0110000";
					errorled <= '0';
				--4
				when "0100" =>
					sevenseg2 <= "0011001";
					errorled <= '0';
				--5
				when "0101" =>
					sevenseg2 <= "0010010";
					errorled <= '0';
				--6
				when "0110" =>
					sevenseg2 <= "0000010";
					errorled <= '0';
				--7
				when "0111" =>
					sevenseg2 <= "1111000";
					errorled <= '0';
				--8
				when "1000" =>
					sevenseg2 <= "0000000";
					errorled <= '0';
				--9
				when "1001" =>
					sevenseg2 <= "0011000";
					errorled <= '0';
				--A
				when "1010" =>
					sevenseg2 <= "0001000";
					errorled <= '0';
				--b
				when "1011" =>
					sevenseg2 <= "0000011";
					errorled <= '0';
				--C
				when "1100" =>
					sevenseg2 <= "1000110";
					errorled <= '0';
				--d
				when "1101" =>
					sevenseg2 <= "0100001";
					errorled <= '0';
				--E
				when "1110" =>
					sevenseg2 <= "0000110";
					errorled <= '0';
				--F
				when "1111" =>
					sevenseg2 <= "0001110";
					errorled <= '0';
				when others =>
					sevenseg2 <= "1111111";
					errorled <= '1';
			end case;
			case bits is
				--0
				when "0000" =>
					sevenseg <= "1000000";
					errorled <= '0';
				--1
				when "0001" =>
					sevenseg <= "1111001";
					errorled <= '0';
				--2
				when "0010" =>
					sevenseg <= "0100100";
					errorled <= '0';
				--3
				when "0011" =>
					sevenseg <= "0110000";
					errorled <= '0';
				--4
				when "0100" =>
					sevenseg <= "0011001";
					errorled <= '0';
				--5
				when "0101" =>
					sevenseg <= "0010010";
					errorled <= '0';
				--6
				when "0110" =>
					sevenseg <= "0000010";
					errorled <= '0';
				--7
				when "0111" =>
					sevenseg <= "1111000";
					errorled <= '0';
				--8
				when "1000" =>
					sevenseg <= "0000000";
					errorled <= '0';
				--9
				when "1001" =>
					sevenseg <= "0011000";
					errorled <= '0';
				--A
				when "1010" =>
					sevenseg <= "0001000";
					errorled <= '0';
				--b
				when "1011" =>
					sevenseg <= "0000011";
					errorled <= '0';
				--C
				when "1100" =>
					sevenseg <= "1000110";
					errorled <= '0';
				--d
				when "1101" =>
					sevenseg <= "0100001";
					errorled <= '0';
				--E
				when "1110" =>
					sevenseg <= "0000110";
					errorled <= '0';
				--F
				when "1111" =>
					sevenseg <= "0001110";
					errorled <= '0';
				when others =>
					sevenseg2 <= "1111111";
					errorled <= '1';
			end case;
		end process;
end behav;
